local enabled = true
local objPos = {986, 1093.5, 22}
local workingHours = {22, 6}
local sBallSize = 2 -- Размер шара
local sSpecularPower = 5 -- specular power
local gRotAngle = { 2, 1, 0.5 } -- rotation speed (yaw , roll ,pitch)
local gSelfShadow = 0.35 -- projection normal - the higher value, the more the ball texture "sticks" to the surfaces
local maxDistance = 160 -- the shader will be applied to textures nearer than maxDistance only
local gLightFade = { 150, 110, 55, 33 }  -- draw distance parameters (max_fade_effect,min_fade_effect,max_fade_light,min_fade_light)

local objBall = createObject(2114, objPos[1], objPos[2], objPos[3], 0, 0, 0, true)
setElementInterior (objBall, 0)
setElementFrozen(objBall, true)
setElementCollisionsEnabled (objBall, false)
local texBall = dxCreateTexture ( "textures/cubebox.dds" )

local removeList = {
						"",							-- unnamed
						"basketball2","skybox_tex",	"flashlight_*",     -- other
						"muzzle_texture*",								-- guns
						"font*","radar*","sitem16","snipercrosshair",	-- hud
						"siterocket","cameracrosshair",					-- hud
						"fireba*","wjet6",								-- flame
						"vehiclegeneric256","vehicleshatter128", 		-- vehicles
						"*shad*",										-- shadows
						"coronastar","coronamoon","coronaringa",
						"coronaheadlightline",							-- coronas
						"lunar",										-- moon
						"tx*",											-- grass effect
						"lod*",										-- lod models
						"cj_w_grad",									-- checkpoint texture
						"*cloud*",										-- clouds
						"*smoke*",										-- smoke
						"sphere_cj",									-- nitro heat haze mask
						"particle*",									-- particle skid and maybe others
						"water*","newaterfal1_256",
						"boatwake*","splash_up","carsplash_*",			-- splash
						"gensplash","wjet4","bubbles","blood*",			-- splash
						"fist","*icon","headlight*",
						"unnamed",	
						"sl_dtwinlights*","nitwin01_la","sfnite*","shad_exp",
						"vgsn_nl_strip","blueshade*",
					}

local reApplyList = {
					"ws_tunnelwall2smoked", "shadover_law",
					"greenshade_64", "greenshade2_64", "venshade*", 
					"blueshade2_64",
					}

DBenTimer = setTimer(function()
	local hour, minute = getTime()
	local camX, camY, camZ = getCameraMatrix()
	if enabled and getDistanceBetweenPoints3D(camX, camY, camZ, objPos[1], objPos[2], objPos[3]) < maxDistance and (hour >= workingHours[1] or (hour < workingHours[2] and hour >= 0)) then
		if not isElement(shWrd) then
			-- world
			shWrd = dxCreateShader ( "fx/shader_light.fx" ,1 , maxDistance,true, "world,object,ped" )
			dxSetShaderValue( shWrd, "sLightPosition",objPos )
			dxSetShaderValue( shWrd, "isStr", true )
			dxSetShaderValue ( shWrd, "gBallTexture", texBall )
			dxSetShaderValue ( shWrd, "gRotAngle", gRotAngle )
			dxSetShaderValue ( shWrd, "isVeh", false )
			dxSetShaderValue ( shWrd, "gLightFade", gLightFade )
			dxSetShaderValue ( shWrd, "gSelfShad", gSelfShadow )
			dxSetShaderValue ( shWrd, "isFakeBump", true )
			
			engineApplyShaderToWorldTexture ( shWrd, "*" )
			for _,removeMatch in ipairs(removeList) do
				engineRemoveShaderFromWorldTexture ( shWrd, removeMatch )	
			end
			for _,applyMatch in ipairs(reApplyList) do
				engineApplyShaderToWorldTexture ( shWrd, applyMatch )	
			end	
			-- vehicle
			shVeh = dxCreateShader ( "fx/shader_light.fx" ,1 , maxDistance,true, "vehicle" )
			dxSetShaderValue( shVeh, "sLightPosition",objPos )
			dxSetShaderValue( shVeh, "isStr", true )
			dxSetShaderValue ( shVeh, "gBallTexture", texBall )
			dxSetShaderValue ( shVeh, "gRotAngle", gRotAngle )
			dxSetShaderValue ( shVeh, "isVeh", true)
			dxSetShaderValue ( shVeh, "gLightFade", gLightFade )
			dxSetShaderValue ( shVeh, "gSelfShad", gSelfShadow )
			dxSetShaderValue ( shVeh, "isFakeBump", false )
			
			engineApplyShaderToWorldTexture ( shVeh, "*" )
			engineRemoveShaderFromWorldTexture ( shVeh, "unnamed" )
			-- ball
			shObj = dxCreateShader ( "fx/shader_ball.fx" ,1 , maxDistance,false, "object" ) 
			dxSetShaderValue ( shObj, "gBallTexture", texBall )
			dxSetShaderValue ( shObj, "gRotAngle", gRotAngle )
			dxSetShaderValue ( shObj, "sSpecularPower", sSpecularPower )
			dxSetShaderValue ( shObj, "sBallSize", sBallSize )
			
			engineApplyShaderToWorldTexture ( shObj, "*",objBall)
		end
	else
		if isElement(shWrd) then
			destroyElement(shWrd)
			destroyElement(shVeh)
			destroyElement(shObj)
		end
	end
end
,200, 0)

addCommandHandler("disco", function()
	enabled = not enabled
	outputChatBox("Светомузыка "..(enabled and "включена." or "отключена."))
end)



